<?php

if ($call == 'fetch_all')
{
    $sth = $db->prepare('SELECT t1.*, t2.name as role_name FROM users t1 LEFT JOIN user_roles t2 ON t2.id = t1.user_role_id WHERE t1.company_id = :company_id AND t1.id != :id');
    $sth->execute([
        ':company_id' => $_GET['company_id'],
        ':id' => $_GET['id'],
    ]);
    $employees = $sth->fetchAll(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Personeller başarıyla getirildi.',
        'data' => $employees
    ]);
}

if ($call == 'fetch')
{
    $sth = $db->prepare('SELECT t1.*, t2.name as role_name FROM users t1 LEFT JOIN user_roles t2 ON t2.id = t1.user_role_id WHERE t1.id != :id');
    $sth->execute([
        ':id' => $_GET['id'],
    ]);
    $employee = $sth->fetch(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Personeller başarıyla getirildi.',
        'data' => $employee
    ]);
}

if ($call == 'store')
{
    $data = [
        'company_id' => $_POST['company_id'],
        'user_role_id' => $_POST['user_role_id'],
        'name' => $_POST['name'],
        'email' => $_POST['email'],
        'password' => password_hash($_POST['password'], PASSWORD_DEFAULT),
        'phone' => $_POST['phone'],
        'created_at' => date('Y-m-d H:i:s')
    ];

    $sth = $db->prepare('SELECT * FROM users WHERE email = ?');
    $sth->execute([$_POST['email']]);
    $user = $sth->fetch(PDO::FETCH_ASSOC);

    if ($user)
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Bu e-posta adresi kullanılmaktadır.'
        ]);

        return;
    }

    $checkPhone = $db->query('SELECT * FROM users WHERE phone = ' . formatPhoneNumberTR($_POST['phone']))->fetch(PDO::FETCH_ASSOC);

    if ($checkPhone)
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Bu telefon numarası kullanılmaktadır.'
        ]);

        return;
    }

    $sth = $db->prepare('INSERT INTO users SET ' . getQueryParameters($data));
    $sth->execute($data);

    $userId = $db->lastInsertId();

    echo json_encode([
        'status' => 'success',
        'message' => 'Kayıt başarılı.',
        'data' => $db->query('SELECT * FROM users WHERE id = ' . $userId)->fetch(PDO::FETCH_ASSOC)
    ]);
}

if ($call == 'update')
{
    $data = [
        'id' => $_POST['id'],
        'user_role_id' => $_POST['user_role_id'],
        'name' => $_POST['name'],
        'email' => $_POST['email'],
        'phone' => $_POST['phone'],
    ];

    if ($_POST['update_password'] == 'true')
    {
        $data['password'] = password_hash($_POST['password'], PASSWORD_DEFAULT);
    }

    $sth = $db->prepare('SELECT * FROM users WHERE email = ? AND id != ?');
    $sth->execute([$_POST['email'], $_POST['id']]);
    $checkEmail = $sth->fetch(PDO::FETCH_ASSOC);

    if ($checkEmail)
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Bu e-posta adresi kullanılmaktadır.'
        ]);

        return;
    }

    $sth = $db->prepare('UPDATE users SET ' . getQueryParameters($data, ['id']) . ' WHERE id = :id');
    $sth->execute($data);

    echo json_encode([
        'status' => 'success',
        'message' => 'Güncelleme başarılı.',
        'data' => $db->query('SELECT * FROM users WHERE id = ' . $data['id'])->fetch(PDO::FETCH_ASSOC)
    ]);
}

if ($call == 'destroy')
{
    $employee = $db->query('SELECT * FROM users WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

    if (!$employee) {
        echo json_encode([
            'status' => 'error',
            'message' => 'Personel bulunamadı',
        ]);

        return;
    }

    $delete = $db->prepare('DELETE FROM users WHERE id = :id');
    $delete->execute(['id' => $_GET['id']]);

    echo json_encode([
        'status' => 'success',
        'message' => 'Personel başarıyla silindi',
    ]);
}