<?php

function getQueryParameters($parameters, $exclude = [])
{
    if (count($exclude) > 0)
    {
        foreach ($exclude as $key)
        {
            unset($parameters[$key]);
        }
    }

    $query = '';

    foreach ($parameters as $key => $parameter)
    {
        $query .= $key . ' = :' . $key . ', ';
    }

    return rtrim($query, ', ');
}

function moneyFormat($number)
{
    $number = number_format($number, 2);
    $number = str_replace(',', '', $number);
    return $number;
}

function slugifyTurkish($text)
{
    $text = trim($text);
    $text = mb_strtolower($text, 'UTF-8');
    $text = preg_replace('/[^a-z0-9]/i', ' ', $text);
    $text = preg_replace('/\s\s+/', ' ', $text);
    $text = trim($text);
    $text = str_replace(' ', '-', $text);
    return $text;
}

function formatPhoneNumberTR($phoneNumber) {
    // Rakamları ve boşlukları kaldır
    $cleanedNumber = preg_replace('/[^0-9]/', '', $phoneNumber);

    // Türkiye'de cep telefonu numarasının uzunluğunu kontrol et
    if (strlen($cleanedNumber) == 11 || strlen($cleanedNumber) == 10) {
        // Numarayı "5XX-XXX-XX-XX" formatına dönüştür
        $formattedNumber = preg_replace('/(\d{1})(\d{3})(\d{3})(\d{2})(\d{2})/', '$1$2$3$4$5', $cleanedNumber);

        if (strlen($formattedNumber) == 11) {
            // remove first digit
            $formattedNumber = substr($formattedNumber, 1);
        }

        return $formattedNumber;
    } else {
        // Geçersiz numara uzunluğu
        return false;
    }
}