<?php

if ($call == 'fetch_all')
{
    $orderProducts = $db->prepare('SELECT * FROM order_products WHERE user_id = :user_id AND order_id = :order_id ORDER BY created_at DESC');

    echo json_encode([
        'status' => 'success',
        'message' => 'Ürünler başarıyla getirildi',
        'data' => $orderProducts,
    ]);
}

if ($call == 'fetch')
{
    $product = $db->query('SELECT * FROM products WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Ürün başarıyla getirildi',
        'data' => $product,
    ]);
}

if ($call == 'store')
{
    $product = $db->prepare('INSERT INTO products (user_id, name, type, color, unit_price, quantity, other_features, created_at, updated_at) VALUES (:user_id, :name, :type, :color, :unit_price, :quantity, :other_features, :created_at, :updated_at)');

    $product->execute([
        'user_id' => $_POST['user_id'],
        'name' => $_POST['name'],
        'type' => $_POST['type'],
        'color' => $_POST['color'],
        'unit_price' => $_POST['unit_price'],
        'quantity' => $_POST['quantity'],
        'other_features' => $_POST['other_features'],
        'created_at' => date('Y-m-d H:i:s'),
        'updated_at' => date('Y-m-d H:i:s'),
    ]);

    echo json_encode([
        'status' => 'success',
        'message' => 'Ürün başarıyla eklendi',
        'data' => $db->query('SELECT * FROM products WHERE id = ' . $db->lastInsertId())->fetch(PDO::FETCH_ASSOC),
    ]);
}

if ($call == 'update')
{
    $product = $db->prepare('UPDATE products SET name = :name, type = :type, color = :color, unit_price = :unit_price, quantity = :quantity, other_features = :other_features, updated_at = :updated_at WHERE id = :id');

    $product->execute([
        'id' => $_POST['id'],
        'name' => $_POST['name'],
        'type' => $_POST['type'],
        'color' => $_POST['color'],
        'unit_price' => $_POST['unit_price'],
        'quantity' => $_POST['quantity'],
        'other_features' => $_POST['other_features'],
        'updated_at' => date('Y-m-d H:i:s'),
    ]);

    echo json_encode([
        'status' => 'success',
        'message' => 'Ürün başarıyla güncellendi',
        'data' => $db->query('SELECT * FROM products WHERE id = ' . $_POST['id'])->fetch(PDO::FETCH_ASSOC),
    ]);
}

if ($call == 'destroy')
{
    $product = $db->query('SELECT * FROM products WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

    if (!$product) {
        echo json_encode([
            'status' => 'error',
            'message' => 'Ürün bulunamadı',
        ]);

        return;
    }

    $delete = $db->prepare('DELETE FROM products WHERE id = :id');
    $delete->execute(['id' => $_GET['id']]);

    echo json_encode([
        'status' => 'success',
        'message' => 'Ürün başarıyla silindi',
    ]);
}