<?php

if ($call == 'fetch_all')
{
    $supplies = $db->query('SELECT * FROM supplies WHERE user_id = '. $_GET['user_id'] .' ORDER BY id DESC')->fetchAll(PDO::FETCH_ASSOC);

    foreach ($supplies as $key => $supply)
    {
        $supplies[$key]['products'] = $db->query('SELECT t1.*, COALESCE(CAST(SUM(t2.quantity) AS UNSIGNED), 0) as stock_quantity FROM products t1 LEFT JOIN product_stocks t2 ON t2.product_id = t1.id WHERE t1.id IN ('.$supply['products'].') GROUP BY t1.id')->fetchAll(PDO::FETCH_ASSOC);
        $supplies[$key]['supplier'] = $db->query('SELECT * FROM suppliers WHERE id = '.$supply['supplier_id'])->fetch(PDO::FETCH_ASSOC);
    }

    echo json_encode([
        'status' => 'success',
        'message' => 'Tedarik Geçmişi başarıyla getirildi',
        'data' => $supplies,
    ]);
}

if ($call == 'fetch_statuses')
{
    $statuses = $db->query('SELECT * FROM supply_statuses')->fetchAll(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Tedarik İşlemi durumları başarıyla getirildi',
        'data' => $statuses,
    ]);
}

if ($call == 'fetch_currencies')
{
    $statuses = $db->query('SELECT * FROM currencies')->fetchAll(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Para birimleri başarıyla getirildi',
        'data' => $statuses,
    ]);
}

if ($call == 'fetch')
{
    $supply = $db->query('SELECT * FROM supplies WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

    $supply['supplier'] = $db->query('SELECT * FROM suppliers WHERE id = '.$supply['supplier_id'])->fetch(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Tedarik İşlemi başarıyla getirildi',
        'data' => $supply,
    ]);
}

if ($call == 'store')
{
    $products = json_decode($_POST['products'], true);

    $productIds = [];
    $productsToStock = [];

    $taxRate = $_POST['tax_rate'];
    $discountAmount = $_POST['discount_amount'];
    
    $totalPrice = 0;
    $generalTotalPrice = 0;
    $taxAmount = 0;

    foreach ($products as $product)
    {
        $totalPrice += $product['total_price'];
        $productIds[] = $product['id'];

        $productsToStock[] = [
            'warehouse_id' => $_POST['warehouse_id'],
            'product_id' => $product['id'],
            'quantity' => $product['quantity'],
        ];
    }

    $taxAmount = moneyFormat($totalPrice * $taxRate / 100);
    $generalTotalPrice = moneyFormat($totalPrice + $taxAmount - $discountAmount);
    $discountRate = $discountAmount != 0 ? moneyFormat($discountAmount * 100 / $totalPrice) : 0;

    $data = [
        'user_id' => $_POST['user_id'],
        'company_id' => $_POST['company_id'],
        'supplier_id' => $_POST['supplier_id'],
        'supply_id' => '',
        'name' => $_POST['name'],
        'products' => implode(',', $productIds),
        'supply_date' => $_POST['supply_date'] == '' ? date('Y-m-d') : $_POST['supply_date'],
        'currency_id' => $db->query('SELECT * FROM currencies WHERE is_default = 1')->fetch(PDO::FETCH_ASSOC)['id'],
        'total_price' => $totalPrice,
        'discount_amount' => $discountAmount,
        'discount_rate' => $discountRate,
        'tax_amount' => $taxAmount,
        'tax_rate' => $taxRate,
        'general_total_price' => $generalTotalPrice,
        'advance' => 0,
        'balance' => $generalTotalPrice,
        'total_collection' => $generalTotalPrice,
        'remaining_collection' => $generalTotalPrice,
        'notes' => $_POST['notes'],
        'status' => 'new',
        'created_at' => date('Y-m-d H:i:s'),
        'updated_at' => date('Y-m-d H:i:s'),
    ];

    $create = $db->prepare('INSERT INTO supplies SET ' . getQueryParameters($data));
    
    if (!$create->execute($data))
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Tedarik İşlemi kaydedilirken bir hata oluştu',
        ]);

        return;
    }

    $createdOrderId = $db->lastInsertId();

    $productIds = '';

    foreach ($products as $product)
    {
        $supplyProductData = [
            'user_id' => $_POST['user_id'],
            'company_id' => $_POST['company_id'],
            'supplier_id' => $_POST['supplier_id'],
            'supply_id' => $db->lastInsertId(),
            'product_id' => $product['id'],
            'quantity' => $product['quantity'],
            'unit_price' => $product['unit_price'],
            'total_price' => $product['total_price'],
        ];

        $productIds .= $product['id'] . ',';

        $createOrderProduct = $db->prepare('INSERT INTO supply_products SET ' . getQueryParameters($supplyProductData));
        $createOrderProduct->execute($supplyProductData);
    }

    $productIds = rtrim($productIds, ',');

    $supply = $db->query('SELECT * FROM supplies WHERE id = ' . $createdOrderId)->fetch(PDO::FETCH_ASSOC);
    
    $supply['products'] = $db->query('SELECT * FROM products WHERE id IN ('.$productIds.')')->fetchAll(PDO::FETCH_ASSOC);
    $supply['supplier'] = $db->query('SELECT * FROM suppliers WHERE id = '.$supply['supplier_id'])->fetch(PDO::FETCH_ASSOC);

    if (count($productsToStock) > 0)
    {
        foreach ($productsToStock as $product)
        {
            $checkStock = $db->query('SELECT * FROM product_stocks WHERE warehouse_id = '.$product['warehouse_id'].' AND product_id = '.$product['product_id'])->fetch(PDO::FETCH_ASSOC);

            if ($checkStock)
            {
                $updateStock = $db->prepare('UPDATE product_stocks SET quantity = quantity + :quantity WHERE warehouse_id = :warehouse_id AND product_id = :product_id');
                $updateStock->execute([
                    'warehouse_id' => $product['warehouse_id'],
                    'product_id' => $product['product_id'],
                    'quantity' => $product['quantity'],
                ]);
            }
            else {
                $createStock = $db->prepare('INSERT INTO product_stocks SET warehouse_id = :warehouse_id, product_id = :product_id, quantity = :quantity');
                $createStock->execute([
                    'warehouse_id' => $product['warehouse_id'],
                    'product_id' => $product['product_id'],
                    'quantity' => $product['quantity'],
                ]);
            }
        }
    }

    echo json_encode([
        'status' => 'success',
        'message' => 'Tedarik İşlemi başarıyla kaydedildi',
        'data' => $supply,
    ]);
}

// if ($call == 'destroy')
// {
//     $supplier = $db->query('SELECT * FROM suppliers WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

//     if (!$supplier) {
//         echo json_encode([
//             'status' => 'error',
//             'message' => 'Müşteri bulunamadı',
//         ]);

//         return;
//     }

//     $delete = $db->prepare('DELETE FROM suppliers WHERE id = :id');
//     $delete->execute(['id' => $_GET['id']]);

//     echo json_encode([
//         'status' => 'success',
//         'message' => 'Müşteri başarıyla silindi',
//     ]);
// }