<?php

if ($call == 'fetch_all')
{
    $sth = $db->prepare('SELECT * FROM users');
    $sth->execute();
    $users = $sth->fetchAll(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Kullanıcılar başarıyla getirildi.',
        'data' => $users
    ]);
}

if ($call == 'login')
{
    $email = $_POST['email'];
    $password = $_POST['password'];

    $sth = $db->prepare('SELECT * FROM users WHERE email = ?');
    $sth->execute([$email]);
    $user = $sth->fetch(PDO::FETCH_ASSOC);

    if (!$user)
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Kullanıcı bulunamadı.'
        ]);

        return;
    }

    if (!password_verify($password, $user['password']))
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Şifre yanlış.'
        ]);

        return;
    }

    $user['role'] = $db->query('SELECT * FROM user_roles WHERE id = ' . $user['user_role_id'])->fetch(PDO::FETCH_ASSOC);
    $user['permissions'] = $user['role']['permissions'] ?? null;

    echo json_encode([
        'status' => 'success',
        'message' => 'Giriş başarılı.',
        'data' => $user
    ]);
}

if ($call == 'register')
{
    $email = $_POST['email'];
    $password = $_POST['password'];
    $phone = $_POST['phone'];

    $sth = $db->prepare('SELECT * FROM users WHERE email = ?');
    $sth->execute([$email]);
    $user = $sth->fetch(PDO::FETCH_ASSOC);

    if ($user)
    {
        echo json_encode([
            'success' => false,
            'message' => 'Bu e-posta adresi kullanılmaktadır.'
        ]);

        return;
    }

    $sth = $db->prepare('INSERT INTO users (email, password, phone) VALUES (?, ?, ?)');
    $sth->execute([$email, password_hash($password, PASSWORD_DEFAULT), $phone]);

    echo json_encode([
        'status' => 'success',
        'message' => 'Kayıt başarılı.',
        'data' => $db->query('SELECT * FROM users WHERE id = ' . $db->lastInsertId())->fetch(PDO::FETCH_ASSOC)
    ]);
}

if ($call == 'register_company')
{
    $userData = [
        'name' => $_POST['name'],
        'email' => $_POST['email'],
        'password' => password_hash($_POST['password'], PASSWORD_DEFAULT),
        'phone' => $_POST['phone'],
        'created_at' => date('Y-m-d H:i:s')
    ];

    $sth = $db->prepare('SELECT * FROM users WHERE email = ?');
    $sth->execute([$_POST['email']]);
    $user = $sth->fetch(PDO::FETCH_ASSOC);

    if ($user)
    {
        echo json_encode([
            'success' => false,
            'message' => 'Bu e-posta adresi kullanılmaktadır.'
        ]);

        return;
    }

    $sth = $db->prepare('INSERT INTO users SET ' . getQueryParameters($userData));
    $sth->execute($userData);

    $userId = $db->lastInsertId();

    // Create company

    $companyData = [
        'name' => $_POST['company_name'],
        'admin_user_id' => $userId,
        'demo_start_date' => date('Y-m-d'),
        'demo_end_date' => date('Y-m-d', strtotime('+1 month')),
        'created_at' => date('Y-m-d H:i:s'),
    ];

    $sth = $db->prepare('INSERT INTO companies SET ' . getQueryParameters($companyData));
    $sth->execute($companyData);

    $companyId = $db->lastInsertId();

    // Set user company id

    $sth = $db->prepare('UPDATE users SET company_id = ? WHERE id = ?');
    $sth->execute([$companyId, $userId]);

    echo json_encode([
        'status' => 'success',
        'message' => 'Kayıt başarılı.',
        'data' => $db->query('SELECT * FROM users WHERE id = ' . $userId)->fetch(PDO::FETCH_ASSOC)
    ]);
}