<?php

if ($call == 'fetch_all')
{
    $sth = $db->prepare('SELECT * FROM user_roles WHERE company_id = :company_id');
    $sth->execute([
        ':company_id' => $_GET['company_id'],
    ]);
    $roles = $sth->fetchAll(PDO::FETCH_ASSOC);

    // foreach ($roles as $key => $role)
    // {
    //     // $sth = $db->prepare('SELECT * FROM user_role_permissions WHERE user_role_id = :user_role_id');
    //     // $sth->execute([
    //     //     ':user_role_id' => $role['id'],
    //     // ]);
    //     // $role['permissions'] = $sth->fetchAll(PDO::FETCH_ASSOC);

    //     $roles[$key]['permissions'] = $role;
    // }

    echo json_encode([
        'status' => 'success',
        'message' => 'Roller başarıyla getirildi.',
        'data' => $roles
    ]);
}

if ($call == 'fetch')
{
    $sth = $db->prepare('SELECT t1.*, t2.name as role_name FROM users t1 LEFT JOIN user_roles t2 ON t2.id = t1.user_role_id WHERE t1.id != :id');
    $sth->execute([
        ':id' => $_GET['id'],
    ]);
    $employee = $sth->fetch(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Personeller başarıyla getirildi.',
        'data' => $employee
    ]);
}

if ($call == 'store')
{
    $data = [
        'company_id' => $_POST['company_id'],
        'name' => $_POST['name'],
        'code' => slugifyTurkish($_POST['name']),
        'permissions' => $_POST['permissions'],
        'created_by' => $_POST['created_by'],
        'created_at' => date('Y-m-d H:i:s')
    ];

    $checkExist = $db->prepare('SELECT * FROM user_roles WHERE company_id = :company_id AND name = :name');
    $checkExist->execute([
        'company_id' => $_POST['company_id'],
        'name' => $_POST['name'],
    ]);
    
    $role = $checkExist->fetch(PDO::FETCH_ASSOC);

    if ($role)
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Bu rol zaten mevcut.',
        ]);

        return;
    }

    $sth = $db->prepare('INSERT INTO user_roles SET ' . getQueryParameters($data));
    $sth->execute($data);

    $roleId = $db->lastInsertId();

    echo json_encode([
        'status' => 'success',
        'message' => 'Kayıt başarılı.',
        'data' => $db->query('SELECT * FROM user_roles WHERE id = ' . $roleId)->fetch(PDO::FETCH_ASSOC)
    ]);
}

if ($call == 'update')
{
    $checkExist = $db->prepare('SELECT * FROM user_roles WHERE company_id = :company_id AND name = :name AND id != :id');
    $checkExist->execute([
        'company_id' => $_POST['company_id'],
        'name' => $_POST['name'],
        'id' => $_POST['id'],
    ]);
    
    $role = $checkExist->fetch(PDO::FETCH_ASSOC);

    if ($role)
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Bu rol zaten mevcut.',
        ]);

        return;
    }

    $data = [
        'id' => $_POST['id'],
        'name' => $_POST['name'],
        'permissions' => $_POST['permissions'],
    ];

    $sth = $db->prepare('UPDATE user_roles SET ' . getQueryParameters($data, ['id']) . ' WHERE id = :id');
    $sth->execute($data);

    echo json_encode([
        'status' => 'success',
        'message' => 'Güncelleme başarılı.',
        'data' => $db->query('SELECT * FROM user_roles WHERE id = ' . $data['id'])->fetch(PDO::FETCH_ASSOC)
    ]);
}

if ($call == 'fetch_system_role_modules')
{
    $systemRoleModules = $db->query('SELECT * FROM system_modules')->fetchAll(PDO::FETCH_ASSOC);

    foreach ($systemRoleModules as $key => $systemRoleModule)
    {
        $permissionList = $systemRoleModule['permission_types'];

        $systemRoleModules[$key]['permissions'] = $db->query('SELECT * FROM system_module_permission_types WHERE id IN ('.$permissionList.')')->fetchAll(PDO::FETCH_ASSOC);
    }

    echo json_encode([
        'status' => 'success',
        'message' => 'Sistem Rol Modülleri başarıyla getirildi.',
        'data' => $systemRoleModules
    ]);
}

if ($call == 'destroy')
{
    $employee = $db->query('SELECT * FROM user_roles WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

    if (!$employee) {
        echo json_encode([
            'status' => 'error',
            'message' => 'Yetki Grubu bulunamadı',
        ]);

        return;
    }

    $checkIfUsed = $db->query('SELECT * FROM users WHERE user_role_id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

    if ($checkIfUsed) {
        echo json_encode([
            'status' => 'error',
            'message' => 'Bu yetki grubu kullanıldığı için silinemez',
        ]);

        return;
    }

    $delete = $db->prepare('DELETE FROM user_roles WHERE id = :id');
    $delete->execute(['id' => $_GET['id']]);

    echo json_encode([
        'status' => 'success',
        'message' => 'Yetki Grubu başarıyla silindi',
    ]);
}