<?php

if ($call == 'fetch_all')
{
    $sth = $db->prepare('SELECT t1.*, t2.name as area_name FROM warehouses t1 LEFT JOIN warehouse_areas t2 ON t2.id = t1.area_id WHERE t1.company_id = :company_id');
    
    $sth->execute([
        ':company_id' => $_GET['company_id'],
    ]);
    
    $data = $sth->fetchAll(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Depolar başarıyla getirildi.',
        'data' => $data
    ]);
}

if ($call == 'fetch')
{
    $sth = $db->prepare('SELECT t1.* FROM warehouses t1 WHERE t1.id != :id');
    $sth->execute([
        ':id' => $_GET['id'],
    ]);

    $data = $sth->fetch(PDO::FETCH_ASSOC);

    echo json_encode([
        'status' => 'success',
        'message' => 'Depo başarıyla getirildi.',
        'data' => $data
    ]);
}

if ($call == 'store')
{
    $data = [
        'company_id' => $_POST['company_id'],
        'name' => $_POST['name'],
        'area_id' => $_POST['area_id'],
        'created_by' => $_POST['user_id'],
    ];

    $sth = $db->prepare('SELECT id FROM warehouses WHERE name = ? LIMIT 1');
    $sth->execute([$_POST['name']]);
    $checkName = $sth->fetch(PDO::FETCH_ASSOC);

    if ($checkName)
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Bu Depo adı kullanılmaktadır.'
        ]);

        return;
    }

    $sth = $db->prepare('INSERT INTO warehouses SET ' . getQueryParameters($data));
    $sth->execute($data);

    $id = $db->lastInsertId();

    echo json_encode([
        'status' => 'success',
        'message' => 'Kayıt başarılı.',
        'data' => $db->query('SELECT * FROM warehouses WHERE id = ' . $id)->fetch(PDO::FETCH_ASSOC)
    ]);
}

if ($call == 'update')
{
    $data = [
        'id' => $_POST['id'],
        'name' => $_POST['name'],
        'area_id' => $_POST['area_id'],
    ];

    $sth = $db->prepare('SELECT id FROM warehouses WHERE name = ? AND id != ? LIMIT 1');
    $sth->execute([$_POST['name'], $_POST['id']]);
    $checkName = $sth->fetch(PDO::FETCH_ASSOC);

    if ($checkName)
    {
        echo json_encode([
            'status' => 'error',
            'message' => 'Bu Depo adı kullanılmaktadır.'
        ]);

        return;
    }

    $sth = $db->prepare('UPDATE warehouses SET ' . getQueryParameters($data, ['id']) . ' WHERE id = :id');
    $sth->execute($data);

    echo json_encode([
        'status' => 'success',
        'message' => 'Güncelleme başarılı.',
        'data' => $db->query('SELECT * FROM warehouses WHERE id = ' . $data['id'])->fetch(PDO::FETCH_ASSOC)
    ]);
}

if ($call == 'destroy')
{
    $checkExists = $db->query('SELECT * FROM warehouses WHERE id = ' . $_GET['id'])->fetch(PDO::FETCH_ASSOC);

    if (!$checkExists) {
        echo json_encode([
            'status' => 'error',
            'message' => 'Depo bulunamadı.',
        ]);

        return;
    }

    $delete = $db->prepare('DELETE FROM warehouses WHERE id = :id');
    $delete->execute(['id' => $_GET['id']]);

    echo json_encode([
        'status' => 'success',
        'message' => 'Depo başarıyla silindi',
    ]);
}